jdk-24/test/jdk/javax/imageio/plugins/external_plugin_tests/TestClassPathPlugin.sh
Sean Mullan db85090553 8338411: Implement JEP 486: Permanently Disable the Security Manager
Co-authored-by: Sean Mullan <mullan@openjdk.org>
Co-authored-by: Alan Bateman <alanb@openjdk.org>
Co-authored-by: Weijun Wang <weijun@openjdk.org>
Co-authored-by: Aleksei Efimov <aefimov@openjdk.org>
Co-authored-by: Brian Burkhalter <bpb@openjdk.org>
Co-authored-by: Daniel Fuchs <dfuchs@openjdk.org>
Co-authored-by: Harshitha Onkar <honkar@openjdk.org>
Co-authored-by: Joe Wang <joehw@openjdk.org>
Co-authored-by: Jorn Vernee <jvernee@openjdk.org>
Co-authored-by: Justin Lu <jlu@openjdk.org>
Co-authored-by: Kevin Walls <kevinw@openjdk.org>
Co-authored-by: Lance Andersen <lancea@openjdk.org>
Co-authored-by: Naoto Sato <naoto@openjdk.org>
Co-authored-by: Roger Riggs <rriggs@openjdk.org>
Co-authored-by: Brent Christian <bchristi@openjdk.org>
Co-authored-by: Stuart Marks <smarks@openjdk.org>
Co-authored-by: Ian Graves <igraves@openjdk.org>
Co-authored-by: Phil Race <prr@openjdk.org>
Co-authored-by: Erik Gahlin <egahlin@openjdk.org>
Co-authored-by: Jaikiran Pai <jpai@openjdk.org>
Reviewed-by: kevinw, aivanov, rriggs, lancea, coffeys, dfuchs, ihse, erikj, cjplummer, coleenp, naoto, mchung, prr, weijun, joehw, azvegint, psadhukhan, bchristi, sundar, attila
2024-11-12 17:16:15 +00:00

94 lines
2.7 KiB
Bash

#
# Copyright (c) 2015, 2024, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
# @test
# @bug 8081729 8140314
# @summary Test external plugin as classpath jar and as a modular jar.
set -e
exception=0
if [ -z "$TESTJAVA" ]; then
if [ $# -lt 1 ]; then echo "No Java path specified. Exiting."; fi
if [ $# -lt 1 ]; then exit 1; fi
TESTJAVA="$1"; shift
COMPILEJAVA="${TESTJAVA}"
TESTSRC="`pwd`"
TESTCLASSES="`pwd`"
fi
JAVAC="$COMPILEJAVA/bin/javac"
JAR="$COMPILEJAVA/bin/jar"
JAVA="$TESTJAVA/bin/java ${TESTVMOPTS}"
TESTDIR="$TESTCLASSES/classes"
PLUGINDIR="$TESTCLASSES/classes"
mkdir -p $TESTDIR
$JAVAC -d $TESTDIR `find $TESTSRC/src/simptest -name "*.java"`
# compile the plugin java sources and services file into a temp location.
mkdir -p $TESTCLASSES/tmpdir/simp
cp -r $TESTSRC/src/simp/META-INF $TESTCLASSES/tmpdir
$JAVAC -d $TESTCLASSES/tmpdir `find $TESTSRC/src/simp -name "*.java"`
# create modular jar file (inc. module-info.java) from the class files.
mkdir -p $PLUGINDIR
$JAR cf $PLUGINDIR/simp.jar -C $TESTCLASSES/tmpdir META-INF/services \
-C $TESTCLASSES/tmpdir module-info.class -C $TESTCLASSES/tmpdir simp
OS=`uname -s`
case "$OS" in
Windows_* | CYGWIN* )
CPSEP=";"
;;
* )
CPSEP=":"
;;
esac
# expect to find SimpReader via jar on classpath.
# Will be treated as a regular jar.
echo "Test classpath jar .. "
$JAVA -cp ${TESTDIR}${CPSEP}${PLUGINDIR}/simp.jar simptest.TestSIMPPlugin
if [ $? -ne 0 ]; then
exception=1
echo "Classpath test failed: exception thrown!"
fi
# expect to find SimpReader on module path
echo "Test modular jar .. "
$JAVA --module-path $PLUGINDIR -cp $TESTDIR simptest.TestSIMPPlugin
if [ $? -ne 0 ]; then
exception=1
echo "modular jar test failed: exception thrown!"
fi
if [ $exception -ne 0 ]; then
echo "TEST FAILED"
exit 1
fi
exit 0